package com.tfg.mwc14.common;

import java.util.ArrayList;
import java.util.HashMap;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.tfg.mwc14.R;
import com.tfg.mwc14.auxiliary.ImageLoader;
 
public abstract class BaseListViewAdapter extends BaseAdapter {
 
    // Declare Variables
	protected Context context;
    protected ArrayList<HashMap<String, String>> data;
    private ImageLoader imageLoader;    
 
    public BaseListViewAdapter(Context context, ArrayList<HashMap<String, String>> data) {
        this.context = context; 
        this.data = data;
        imageLoader = new ImageLoader(context);
    }
 
    @Override
    public int getCount() {
        return data.size();        
    }
 
    @Override
    public Object getItem(int position) { 
        return null;
    }
 
    @Override
    public long getItemId(int position) {
        return 0;
    }
    
    public View getView(final int position, View convertView, ViewGroup parent) {        
        View itemView = ((LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE)).inflate(R.layout.listview_item, parent, false);        
        // Get a particular element from the list
        final HashMap<String, String> element = data.get(position);
        // sets the text field and the preview image
        TextView title = (TextView) itemView.findViewById(R.id.list_title);
        title.setText(element.get("titulo"));
        ImageView preview = (ImageView) itemView.findViewById(R.id.list_preview);        
        imageLoader.DisplayImage(element.get("img"), preview);				 
  
        return itemView;
    }
}