package com.tfg.mwc14.common;

import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.os.Bundle;
import android.os.Handler;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.ImageView;
import android.widget.ImageView.ScaleType;

import com.actionbarsherlock.app.SherlockActivity;
import com.actionbarsherlock.view.MenuItem;
import com.tfg.mwc14.auxiliary.ImageLoader;

public class ImageViewActivity extends SherlockActivity {

	private Handler mHandler;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);			
		//setContentView(R.layout.image_view_activity);			
		// gets the extras
		String img = "", title = "";
		if (getIntent().getExtras() != null) {
			img = getIntent().getExtras().getString("img");
			title = getIntent().getExtras().getString("title");
		}
		// sets the title, action bar color and home button
		setTitle(title);
		getWindow().requestFeature(Window.FEATURE_ACTION_BAR_OVERLAY);
		ColorDrawable color = new ColorDrawable(Color.WHITE);
		color.setAlpha(128);
		getSupportActionBar().setBackgroundDrawable(color);
		getSupportActionBar().setDisplayHomeAsUpEnabled(true);
		// loads the image and makes it fit the full screen
		mHandler = new Handler();
		ImageLoader imageLoader = new ImageLoader(this);		
		ImageView imageView = new ImageView(this);
		imageView.setScaleType(ScaleType.FIT_CENTER);		
		imageLoader.DisplayImage(img, imageView);
		// show the action bar if the screen is clicked
		imageView.setOnClickListener(new OnClickListener() {
			public void onClick(View v) {
				getSupportActionBar().show();
				hideActionBarDelayed(mHandler);
			}
		});
		setContentView(imageView);
		getWindow().setBackgroundDrawableResource(android.R.color.black);
	}
	
	@Override
	public void onResume() {
		super.onResume();
		getSupportActionBar().show();
		hideActionBarDelayed(mHandler);
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case android.R.id.home:
			finish();
			return true;
		}
		return super.onOptionsItemSelected(item);
	}
	
	// 2 seconds timer to hide the action bar 
	private void hideActionBarDelayed(Handler handler) {
		handler.postDelayed(new Runnable() {
			public void run() {
				getSupportActionBar().hide();
			}
		}, 2000);
	}
	
}