package com.tfg.mwc14.historic;

import java.util.ArrayList;
import java.util.HashMap;

import org.json.JSONException;
import org.json.JSONObject;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

import com.tfg.mwc14.R;
import com.tfg.mwc14.common.BaseFragment;
import com.tfg.mwc14.common.BaseListViewAdapter;
import com.tfg.mwc14.common.Server;
 
public class HistoricFragment extends BaseFragment {
	
	/**
     * Use this to force the fragment to think that is the first time it opens.
     * Leave it static for the love of god.
     */
	public static boolean isFirstTime = true;	
	
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        // Get the view from historic_fragment.xml
        View view = inflater.inflate(R.layout.historic_fragment, container, false);
        context = getActivity();
        
        // every time the fragment gains focus, it tries to load from cache. The first time it opens it will try to download from server.
        data = getDataFromCache("data3");
        if (isFirstTime) {
        	isFirstTime = false;
        	updateFragment(true);
        }
        else
        	updateFragment(false);
        
        return view;
    }
    
    // in this case the download is straightforward. The whole package every time
    @Override
	protected String downloadFromWhere() {    	
    	return "http://" + Server.ip + ":1289/xampp/TFGETASTERISCO/mostrar_historico.php";						
	}

	@Override
	protected void onBackground(JSONObject jsonObject) {
		try {
			data = parse(jsonObject, new ArrayList<HashMap<String, String>>());    		//parse(jsonObject, data);               
    		saveData(data, "data3");
    	}
    	catch (Exception e) {
    		// if the parse went wrong the data table will be messed up, make a empty and safe one
            if (e instanceof JSONException) {		            				            	
            	data = new ArrayList<HashMap<String, String>>();
	           	error = 1;
            	Log.e("Error", "Error parseando el json de historicos " + e.toString());		            		
            }
            // if save fails the data table is not written locally. No local changes are made. 
            else {
            	error = 2;
            	Log.e("Error", "Error guardando la tabla de datos de historicos " + e.toString());
            }
    	}  
	}

	protected void nothingToShow() {
		getView().findViewById(R.id.listview3).setVisibility(View.INVISIBLE); 
    	getView().findViewById(R.id.nothingToShow3).setVisibility(View.VISIBLE);
    }
    
    protected void showTable() {
    	// hides the empty list picture. There's something in the table so we'll show that   
		getView().findViewById(R.id.nothingToShow3).setVisibility(View.INVISIBLE); 
		// Locate the listview in historic_fragment.xml        	
		ListView historicList = (ListView) getView().findViewById(R.id.listview3);        	
		historicList.setVisibility(View.VISIBLE);
        // Pass the results into ListViewAdapter.java
		BaseListViewAdapter adapter = new HistoricListViewAdapter(getActivity(), data);
        // Set the adapter to the ListView
        historicList.setAdapter(adapter);
        // captures the click event
        historicList.setOnItemClickListener(new OnItemClickListener() {
        	@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {					
				Intent intent = new Intent(context, HistoricSingleItemActivity.class);
		        // Pass the data as a hashMap object      
		        intent.putExtra("element", data.get(position));
		        // Puts the position of the element, will be returned by the activity to be deleted of the table
		        intent.putExtra("position", position);  
		        // Start SingleItemView Class 
		        startActivity(intent);  
			}           
        });
    }
}
