package com.tfg.mwc14.inbox;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.RadioButton;
import android.widget.RadioGroup;

import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuItem;
import com.tfg.mwc14.R;
import com.tfg.mwc14.common.BaseSingleItemActivity;
import com.tfg.mwc14.common.Server;

public class InBoxSingleItemActivity extends BaseSingleItemActivity {
	
	private int idR, position;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState); 		
		// gets the position in the table of the element that triggered the activity
		position = getIntent().getIntExtra("position", 0);
        // Gets all the possible answers and adds them to the UI as radio buttons in the same radio group
		RadioGroup answers = ((RadioGroup) findViewById(R.id.answersRadio));
        int i = 0; 
        String resp = element.get("respuesta"+i);        
        while (resp != null) {  
        	RadioButton answer = new RadioButton(this); 
        	answer.setText(resp);        	
        	answer.setId(Integer.parseInt(element.get("idRespuesta"+i)));
        	answer.setChecked(true);
        	answers.addView(answer);        	
        	i++;
        	// sets idR, so we are ready to send something if the listener's code is never executed
        	idR = answer.getId();
        	// gets next possible answer
        	resp = element.get("respuesta"+i); 
        }
        // sets a listener to the group so we know which is the selected button          
        answers.setOnCheckedChangeListener(new RadioGroup.OnCheckedChangeListener() {
            public void onCheckedChanged(RadioGroup rg, int checkedId) {
            	idR = checkedId;                 
            }
       });
	}
	
	@Override
	public boolean onOptionsItemSelected(final MenuItem item) {
		// send button pressed
		if (item.getItemId() == R.id.menu_send) {
			// tries to send the answer to the server (the id of the selected radio button)
			String messageS = "Sending answer";
			String messageE= "Answer sent";	
			String idC = element.get("idConsulta");							
			String data = "&idConsulta=" + idC + "&idRespuesta=" + idR;
			String dir = "http://" + Server.ip + ":1289/xampp/TFGETASTERISCO/resolver_consulta.php";
			sendToServerFunc(messageS, messageE, data, dir);								
			return false;
		}
		// if not send button it belongs to the base menu
		else
			return super.onOptionsItemSelected(item);		
	}
	
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// this menu has the 'send button'
		getSupportMenuInflater().inflate(R.menu.main_menu_add, menu);
		return true;
	}	

	// if the answer process was successful: 1- end the activity 
	// 2- pass the index of the entry to delete (you answered that question, no need to keep it on the local table)
	public void onProcessFinish(boolean success) {
		if (success) {
			Intent result = new Intent(); 
			result.putExtra("position", position); 
			setResult(Activity.RESULT_OK, result);
			finish();					
		}
	}
}
