package com.tfg.mwc14.inprogress;

import java.util.ArrayList;
import java.util.HashMap;

import org.json.JSONException;
import org.json.JSONObject;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ListView;

import com.tfg.mwc14.R;
import com.tfg.mwc14.common.BaseFragment;
import com.tfg.mwc14.common.BaseListViewAdapter;
import com.tfg.mwc14.common.Server;
import com.tfg.mwc14.historic.HistoricFragment;
 
public class InProgressFragment extends BaseFragment {
    
	/**
    * Use this to force the fragment to think that is the first time it opens.
    * Leave it static for the love of god.
    */
	public static boolean isFirstTime = true;	
	
    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        // Get the view from inprogress_fragment.xml
        View view = inflater.inflate(R.layout.inprogress_fragment, container, false);
        context = getActivity();
        
        // every time the fragment gains focus, it tries to load from cache. The first time it opens it will try to download from server.
        data = getDataFromCache("data2");
        if (isFirstTime) {
        	isFirstTime = false;
        	updateFragment(true);
        }
        else
        	updateFragment(false);
        
        return view;
    }       

    // in this case the download is straightforward. The whole package every time
    @Override
	protected String downloadFromWhere() {
    	return "http://" + Server.ip + ":1289/xampp/TFGETASTERISCO/mostrar_consultas_propias.php";				
	}
    	    	
    @Override
    protected void onBackground(JSONObject jsonObject) {
    	try {
    		data = parse(jsonObject, new ArrayList<HashMap<String, String>>());    		//parse(jsonObject, data);		                
    		saveData(data, "data2");
    	}
    	catch (Exception e) {
    		// if the parse went wrong the data table will be messed up, make a empty and safe one
            if (e instanceof JSONException) {		            				            	
            	data = new ArrayList<HashMap<String, String>>();
	           	error = 1;
            	Log.e("Error", "Error parseando el json de activos " + e.toString());		            		
            }
            // if save fails the data table is not written locally. No local changes are made. 
            else {
            	error = 2;
            	Log.e("Error", "Error guardando la tabla de datos de activos " + e.toString());
            }
    	}        
    }
    
    protected void nothingToShow() {
    	getView().findViewById(R.id.listview2).setVisibility(View.INVISIBLE); 
    	getView().findViewById(R.id.nothingToShow2).setVisibility(View.VISIBLE);
    }
    
    protected void showTable() {
    	// hides the empty list picture. There's something in the table so we'll show that   
		getView().findViewById(R.id.nothingToShow2).setVisibility(View.INVISIBLE); 
		// Locate the listview in inprogress_fragment.xml        	
		ListView inprogressList = (ListView) getView().findViewById(R.id.listview2);      
		inprogressList.setVisibility(View.VISIBLE);
        // Pass the results into ListViewAdapter.java
		BaseListViewAdapter adapter = new InProgressListViewAdapter(getActivity(), data);
        // Set the adapter to the ListView
        inprogressList.setAdapter(adapter);
        // captures the click event
        inprogressList.setOnItemClickListener(new OnItemClickListener() {
        	@Override
			public void onItemClick(AdapterView<?> parent, View view, int position, long id) {					
				Intent intent = new Intent(context, InProgressSingleItemActivity.class);
		        // Pass the data as a hashMap object      
		        intent.putExtra("element", data.get(position));
		        // Puts the position of the element, will be returned by the activity to be deleted of the table
		        intent.putExtra("position", position);  
		        // Start SingleItemView Class and wait for it to end
		        startActivityForResult(intent, 3);  
			}           
        });
    }
    
    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent intent) {    	
    	if (requestCode == 3 && resultCode == Activity.RESULT_OK && intent != null) {
    		// deletes the already answered question and saves the list to disk
    		int position = intent.getIntExtra("position", 0);
	    	HashMap<String, String> element = data.get(position);	    	
	    	data.remove(element);
	        try {
	        	saveData(data, "data2");
	        }
	        catch (Exception e) {        	
	        }
	        // tells the historic fragment that it needs a update from server, so it can download this question (belongs there from now on) 
	    	HistoricFragment.isFirstTime = true;
	        // finally updates the fragment from the local data
	        updateFragment(false);    	
    	}
    }
}