package com.tfg.mwc14.inprogress;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.LinearLayout;
import android.widget.RelativeLayout.LayoutParams;
import android.widget.TextView;

import com.actionbarsherlock.view.Menu;
import com.actionbarsherlock.view.MenuItem;
import com.tfg.mwc14.R;
import com.tfg.mwc14.common.BaseSingleItemActivity;
import com.tfg.mwc14.common.Server;

public class InProgressSingleItemActivity extends BaseSingleItemActivity {

	private int position;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState); 
		// gets the position in the table of the element that triggered the activity
		position = getIntent().getIntExtra("position", 0);
		// Gets all the possible answers and adds them to the UI as texts views in a scroll
		LinearLayout answers = ((LinearLayout) findViewById(R.id.answersLabels));
		int i = 0; 
		//  Also adds the counter for each possible answer
		String resp = element.get("respuesta"+i);
		String count = element.get("contador"+i);
		while (resp != null) {  
			TextView answer = new TextView(this); 
		    answer.setText(resp + ": " + count);
		    // android:textSize="20sp"
	        answer.setTextSize(20); 
	        // android:layout_width="wrap_content" android:layout_height="wrap_content"    
	        LinearLayout.LayoutParams llp = new LinearLayout.LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
	        // android:layout_marginTop="10dp"   (left, top, right, bottom)
	        llp.setMargins(0, 15, 0, 0); 
	        answer.setLayoutParams(llp);
		    answers.addView(answer);        	
		    i++;
		    resp = element.get("respuesta"+i);
		    count = element.get("contador"+i);
		}		       
	}
	
	@Override
	protected void onProcessFinish(boolean success) {
		// if the question could be closed (in the server), we return the position of that question in the list so it can be deleted (in local cache)
		if (success) {
			Intent result = new Intent(); 
			result.putExtra("position", position); 
			setResult(Activity.RESULT_OK, result);
			finish();					
		}		
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// this menu has the 'close button'
		getSupportMenuInflater().inflate(R.menu.main_menu_close, menu);
		return true;
	}
	
	@Override
	public boolean onOptionsItemSelected(final MenuItem item) {
		// send button pressed
		if (item.getItemId() == R.id.menu_close) {
			// tries to send the answer to the server (the id of the selected radio button)
			String messageS = "Closing...";
			String messageE= "Done";	
			String idC = element.get("idConsulta");							
			String data = "&idConsulta=" + idC;
			String dir = "http://" + Server.ip + ":1289/xampp/TFGETASTERISCO/cerrar_consulta.php";
			sendToServerFunc(messageS, messageE, data, dir);								
			return false;
		}
		// if not close button it belongs to the base menu
		else
			return super.onOptionsItemSelected(item);		
	}
}
