package com.tfg.mwc14.menu;

import android.os.Bundle;
import android.support.v4.app.ListFragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import com.tfg.mwc14.R;

public class MenuFragment extends ListFragment {
	
	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		// the list layout uses the values in the different dimens files to adapt itself
		return inflater.inflate(R.layout.side_menu, null);
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
		// gets the names of the main options of the app
		String[] names = getResources().getStringArray(R.array.sections);
		// sets the list adapter with parameters: mainActivity, simple style for list items, simple style for text and the names
		setListAdapter(new ArrayAdapter<String>(getActivity(), android.R.layout.simple_list_item_1, android.R.id.text1, names));
	}
	
	@Override
	public void onListItemClick(ListView lv, View v, int position, long id) {		
		// calls the mainActivity to handle the fragment exchange
		((MainActivity) getActivity()).switchContent(position);		
	}
}
